/*
**
**	$Id: CascadeMenuP.h,v 1.4 1994/05/31 08:28:01 masa-k Rel $
**
*/

/*
**  Copyright (C) 1994 Issei Numata  issei@jaist.ac.jp
**
**  NOTICE:
**
**  1) You may use, copy, distribute and sell verbatim copies of this 
**     Program's source code as you receive it with above copyright and
**     this notice.
**
**  2) You may modify your copy or copies of the Program or any portion
**     of it, and use, copy, distribute and sell such modifications with 
**     above copyright and this notice. But, you must specify that this 
**     program is modifyied from original.
*/

#ifndef CASCADE_MENUP_H
#define CASCADE_MENUP_H

#ifndef USE_XAW3D
#include <X11/Xaw/SimpleMenP.h>
#include <X11/Xaw/SmeBSBP.h>
#include <X11/Xaw/SmeLineP.h>
#include <X11/Xaw/SmeP.h>
#else   /* USE_XAW3D */
#include <X11/Xaw3d/SimpleMenP.h>
#include <X11/Xaw3d/SmeBSBP.h>
#include <X11/Xaw3d/SmeLineP.h>
#include <X11/Xaw3d/SmeP.h>
#endif  /* !USE_XAW3D */
#include "CascadeMenu.h"

typedef struct {
  int num_of_widget;
  Widget *widgets;
} CascadeMenuClassPart;

typedef struct _CascadeMenuClassRec{
  CoreClassPart		core_class;
  CompositeClassPart	composite_class;
  ShellClassPart	shell_class;
  OverrideShellClassPart	override_shell_class;
  SimpleMenuClassPart		simpleMenu_Class;
  CascadeMenuClassPart		cascadeMenu_Class;
} CascadeMenuClassRec;

extern CascadeMenuClassRec cascadeMenuClassRec;

typedef struct _CascadeMenuPart {
/*
  XawCascadeType cascade_type;
  Dimension cascade_popup_area;
*/
/**/
  int cascade_level;
  Boolean already_popuped;
  Boolean pointer_in;
  Widget pre_called_widget;
} CascadeMenuPart;

typedef struct _CascadeMenuRec{
  CorePart              core;
  CompositePart         composite;
  ShellPart             shell;
  OverrideShellPart     override;
  SimpleMenuPart        simple_menu;
  CascadeMenuPart	cascade_menu;
} CascadeMenuRec;

#endif

