/*
 *  netaudio (NCDaudio) $B%5%&%s%I=hM}(B
 */

/*
 *  Copyright (c) 1994 Kazuhiko Ishii.
 *
 *  $BK\%=%U%H%&%'%"$N%=!<%9$d%P%$%J%j$r:FG[I[$9$k>l9g$O!"<!$N>r7o$r=e<i$7$F(B
 *  $B2<$5$$!#(B
 *
 *  1. $BK\%=%U%H%&%'%"$rF~<j$7$?J}$K$O!"(BX11$BHG(B Emi Clock $B$N;HMQ8"$H!"Bh;0<T(B
 *     $B$X$N:FG[I[8"$,G'$a$i$l$^$9!#$?$@$7!":FG[I[$K4X$7$F$O!"F~<j;~$N%*%j(B
 *     $B%8%J%k$N$^$^2~JQ$;$:$K9T$&$3$H$,>r7o$G$9!#(B
 *  2. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$G2~JQ$7$FG[I[$9$k$3(B
 *     $B$H$O$G$-$^$;$s!#(B
 *  3. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$GFs<!MxMQ$9$k$3$H$O(B
 *     $B$G$-$^$;$s!#(B
 *  4. $BK\%=%U%H%&%'%"$r%7%9%F%`$K%P%s%I%k$7$?$j!"%7%9%F%`$NDI2C%Q%C%1!<%8(B
 *     $B$H$7$FBh;0<T$K:FG[I[$7$?$j$9$k>l9g$O!";vA0$KCx:n8"<T$K5v2D$,I,MW$G(B
 *     $B$9!#(B
 *  5. $BK\%=%U%H%&%'%"$r>&MQ$K;HMQ$9$k>l9g(B($B6bA,E*Mx1W$rF@$k>l9g(B)$B$O!";vA0$K(B
 *     $BCx:n8"<T$K5v2D$,I,MW$G$9!#$3$N>l9g!"4pK\E*$KM-=~$H$J$j$^$9!#(B
 *  6. $BK\%=%U%H%&%'%"$rMxMQ$9$k$3$H$K$h$C$FH/@8$7$?$$$+$J$kB;32$b!"Cx:n8"(B
 *     $B<T$OIi$o$J$$$b$N$H$7$^$9!#$3$l$K9g0U$G$-$J$$>l9g$O!";HMQ8"$,$J$$$b(B
 *     $B$N$H$7$^$9!#(B
 *  7. $B!H(BEmi Clock$B!I$N>&I8$*$h$SK\%=%U%H%&%'%"$N2hA|$d%G%6%$%s$K4X$9$kCx:n(B
 *     $B8"$O!"(BMotosoft $B$3$H!HK\(B $B=SLi!I;a$,M-$7$^$9!#(B
 *  8. $B!H(BEmi Clock$B!I$N>&I8$*$h$S2hA|$d%G%6%$%s$O!"(BX11$BHG(B Emi Clock $B3+H/$N$?(B
 *     $B$a!"(BMotosoft $B$h$j!H8E>l(B $B@59T!I$X8D?ME*$K%i%$%;%s%96!M?$5$l$F$^$9!#(B
 *     $BBh;0<T$XFs<!%i%$%;%s%96!M?$9$k$3$H$OG'$a$i$l$F$*$j$^$;$s!#(B
 *  9. Motosoft $B$H8E>l$KL5CG$G!"K\%=%U%H%&%'%"$N2hA|%G!<%?$rFs<!MxMQ$9$k$3(B
 *     $B$H$r6X;_$7$^$9!#(B
 * 10. $B$3$3$K5-=R$7$?0J30$N8"Mx$K$D$$$F$O!"F|K\9q$NCx:n8"K!$K$h$k$b$N$H$7(B
 *     $B$^$9!#(B
 */


/* $BDj?t(B */
#define	HAS_SOUND_CODE		/* $B%5%&%s%I4X78$N%3!<%I$OM-8z!*(B */

/* RCS ID */
rcsId(audioId, "$Id: audio.c,v 1.1 1994/06/22 11:59:25 masa-k Rel $")

static AuServer	*Audiofd = NULL;
extern Widget	toplevel;

/*
 *  $B%5%&%s%I4D6-$N=i4|2=(B
 */
static void
S_SoundEnvInit()
{
	if (Audiofd != NULL)
		AuCloseServer(Audiofd);
	if ((Audiofd = AuOpenServer(DisplayString(XtDisplay(toplevel)), 0, NULL, 0, NULL, NULL)) != NULL)
		AuXtAppAddAudioHandler(XtWidgetToApplicationContext(toplevel), Audiofd);
}


/*
 *  $B%5%&%s%I%G%P%$%9$NB8:_H=Dj(B
 */
static Boolean
S_IsSoundAvailable()
{
	return True;
}

/*
 *  $B%5%&%s%I:F@8(B
 */
static int
S_PlaySound(filename)
char	*filename;
{
	if (Audiofd == NULL)
		return SOUND_DEVICE_ERROR;
	if (AuSoundPlayFromFile(Audiofd, filename, AuNone,
					AuFixedPointFromSum(1, 0), NULL, NULL,
					NULL, NULL, NULL, NULL) == NULL)
		return SOUND_OPEN_ERROR;
	return SOUND_NO_ERROR;
}


/*
 *  $B%5%&%s%I$N%-%c%C%7%e2=2DG=!?IT2DG=H=Dj(B
 */
static Boolean
S_IsSoundCacheAvailable()
{
	return True;
}


/*
 *  $B%5%&%s%I$N%-%c%C%7%e2=(B
 */
static int
S_CacheSound(filename, cacheBufferPtr)
char			*filename;
SoundCacheBuffer	*cacheBufferPtr;
{
	if (Audiofd == NULL)
		return SOUND_OPEN_ERROR;
	if ((cacheBufferPtr->bucket = AuSoundCreateBucketFromFile(Audiofd,
			filename, AuAccessAllMasks, NULL, NULL)) == NULL)
		return SOUND_OPEN_ERROR;
	return SOUND_NO_ERROR;
}


/*
 *  $B%-%c%C%7%e2=$5$l$?%5%&%s%I$N:F@8(B
 */
static int
S_PlayCacheSound(cacheBufferPtr)
SoundCacheBuffer	*cacheBufferPtr;
{
	if (Audiofd == NULL)
		return SOUND_DEVICE_ERROR;
	if (AuSoundPlayFromBucket(Audiofd, cacheBufferPtr->bucket, AuNone,
			AuFixedPointFromSum(1, 0), NULL, NULL, 1, NULL, NULL,
			NULL, NULL) == NULL)
		return SOUND_DEVICE_ERROR;
	return SOUND_NO_ERROR;
}


/*
 *  $B%-%c%C%7%e2=$5$l$?%5%&%s%I$N3+J|(B
 */
static void
S_FreeCacheSound(cacheBufferPtr)
SoundCacheBuffer	*cacheBufferPtr;
{
	if (Audiofd != NULL)
		AuDestroyBucket(Audiofd, cacheBufferPtr->bucket, NULL);
}


/*
 *  $B%5%&%s%I4D6-$N8e;OKv(B
 */
static void
S_SoundEnvDispose()
{
	if (Audiofd != NULL) {
		AuCloseServer(Audiofd);
		Audiofd = NULL;
	}
}
