/*
 *  Emi Clock $B!=(B $B2hA|%G!<%?(B
 */

/*
 *  Copyright (c) 1994 Masayuki Koba.
 *
 *  $BK\%=%U%H%&%'%"$N%=!<%9$d%P%$%J%j$r:FG[I[$9$k>l9g$O!"<!$N>r7o$r=e<i$7$F(B
 *  $B2<$5$$!#(B
 *
 *  1. $BK\%=%U%H%&%'%"$rF~<j$7$?J}$K$O!"(BX11$BHG(B Emi Clock $B$N;HMQ8"$H!"Bh;0<T(B
 *     $B$X$N:FG[I[8"$,G'$a$i$l$^$9!#$?$@$7!":FG[I[$K4X$7$F$O!"F~<j;~$N%*%j(B
 *     $B%8%J%k$N$^$^2~JQ$;$:$K9T$&$3$H$,>r7o$G$9!#(B
 *  2. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$G2~JQ$7$FG[I[$9$k$3(B
 *     $B$H$O$G$-$^$;$s!#(B
 *  3. $BK\%=%U%H%&%'%"$N0lIt$^$?$OA4It$rCx:n8"<T$KL5CG$GFs<!MxMQ$9$k$3$H$O(B
 *     $B$G$-$^$;$s!#(B
 *  4. $BK\%=%U%H%&%'%"$r%7%9%F%`$K%P%s%I%k$7$?$j!"%7%9%F%`$NDI2C%Q%C%1!<%8(B
 *     $B$H$7$FBh;0<T$K:FG[I[$7$?$j$9$k>l9g$O!";vA0$KCx:n8"<T$K5v2D$,I,MW$G(B
 *     $B$9!#(B
 *  5. $BK\%=%U%H%&%'%"$r>&MQ$K;HMQ$9$k>l9g(B($B6bA,E*Mx1W$rF@$k>l9g(B)$B$O!";vA0$K(B
 *     $BCx:n8"<T$K5v2D$,I,MW$G$9!#$3$N>l9g!"4pK\E*$KM-=~$H$J$j$^$9!#(B
 *  6. $BK\%=%U%H%&%'%"$rMxMQ$9$k$3$H$K$h$C$FH/@8$7$?$$$+$J$kB;32$b!"Cx:n8"(B
 *     $B<T$OIi$o$J$$$b$N$H$7$^$9!#$3$l$K9g0U$G$-$J$$>l9g$O!";HMQ8"$,$J$$$b(B
 *     $B$N$H$7$^$9!#(B
 *  7. $B!H(BEmi Clock$B!I$N>&I8$*$h$SK\%=%U%H%&%'%"$N2hA|$d%G%6%$%s$K4X$9$kCx:n(B
 *     $B8"$O!"(BMotosoft $B$3$H!HK\(B $B=SLi!I;a$,M-$7$^$9!#(B
 *  8. $B!H(BEmi Clock$B!I$N>&I8$*$h$S2hA|$d%G%6%$%s$O!"(BX11$BHG(B Emi Clock $B3+H/$N$?(B
 *     $B$a!"(BMotosoft $B$h$j!H8E>l(B $B@59T!I$X8D?ME*$K%i%$%;%s%96!M?$5$l$F$^$9!#(B
 *     $BBh;0<T$XFs<!%i%$%;%s%96!M?$9$k$3$H$OG'$a$i$l$F$*$j$^$;$s!#(B
 *  9. Motosoft $B$H8E>l$KL5CG$G!"K\%=%U%H%&%'%"$N2hA|%G!<%?$rFs<!MxMQ$9$k$3(B
 *     $B$H$r6X;_$7$^$9!#(B
 * 10. $B$3$3$K5-=R$7$?0J30$N8"Mx$K$D$$$F$O!"F|K\9q$NCx:n8"K!$K$h$k$b$N$H$7(B
 *     $B$^$9!#(B
 */


/* $B#X%D!<%k%-%C%H%W%m%0%i%_%s%0$KI,MW$J%X%C%@!<(B */
#include <X11/Intrinsic.h>		/* $B%$%s%H%j%s%7%C%/$NDj5A(B */

/* Emi Clock $BFH<+$N%X%C%@!<(B */
#include "include/const.h"		/* $BDj?tDj5A(B */
#include "include/types.h"		/* $BFC<l$J7?$NDj5A(B */
#include "include/util.h"		/* $B%^%/%mDj5A(B */

/* RCS ID */
rcsId(gdataId, "$Id: gdata.c,v 1.3 1994/05/26 16:30:41 masa-k Rel $")


/*
 *  8 plane $B2hA|%G!<%?(B (PixelImage $B%G!<%?(B)
 */

#include "graphics/8-plane/cbase1.h" /* $BJ8;zHW(B $B!=(B $B%T%/%A%c!J@D!K(B */
#include "graphics/8-plane/cbase2.h" /* $BJ8;zHW(B $B!=(B $B?t;z!J@V!K(B */
#include "graphics/8-plane/char01.h" /* $B%-%c%i%/%?(B $B!=(B $B$$$D$bCe$F$$$kI~(B */
#include "graphics/8-plane/char02.h" /* $B%-%c%i%/%?(B $B!=(B $B6PL3@h$N@)I~(B */
#include "graphics/8-plane/char03.h" /* $B%-%c%i%/%?(B $B!=(B $B?e6L$N%o%s%T!<%9(B */
#include "graphics/8-plane/char04.h" /* $B%-%c%i%/%?(B $B!=(B $B%;!<%i!<I~!JGr!K(B */
#include "graphics/8-plane/char05.h" /* $B%-%c%i%/%?(B $B!=(B $B%;!<%i!<I~!J:0!K(B */
#include "graphics/8-plane/char06.h" /* $B%-%c%i%/%?(B $B!=(B $B$L$$$0$k$_9b9;@)I~(B */
#include "graphics/8-plane/char07.h" /* $B%-%c%i%/%?(B $B!=(B $B9b9;$N@)I~$K%;!<%?!<(B */
#include "graphics/8-plane/char08.h" /* $B%-%c%i%/%?(B $B!=(B $BBNA`I~$H%V%k%^(B */
#include "graphics/8-plane/char09.h" /* $B%-%c%i%/%?(B $B!=(B $B%9%/!<%k?eCe(B */
#include "graphics/8-plane/char10.h" /* $B%-%c%i%/%?(B $B!=(B $B%m!<%l%0$N?eCe!J@V!K(B */
#include "graphics/8-plane/char11.h" /* $B%-%c%i%/%?(B $B!=(B $B$d$5$7$$IX7Y$5$s(B */
#include "graphics/8-plane/char12.h" /* $B%-%c%i%/%?(B $B!=(B $B4G8nIX$5$s$NGr0a(B */
#include "graphics/8-plane/char13.h" /* $B%-%c%i%/%?(B $B!=(B X11$B65=$F;1!$N%7%9%?!<(B */
#include "graphics/8-plane/char14.h" /* $B%-%c%i%/%?(B $B!=(B $B%A%c%$%J%I%l%9(B */
#include "graphics/8-plane/char15.h" /* $B%-%c%i%/%?(B $B!=(B $B=w@o;N@oF.I~(B */
#include "graphics/8-plane/char16.h" /* $B%-%c%i%/%?(B $B!=(B $B%O%$%Q!<%P%H%k%9!<%D(B */
#include "graphics/8-plane/char17.h" /* $B%-%c%i%/%?(B $B!=(B $BD6%_%K$N%&%(%$%H%l%9(B */
#include "graphics/8-plane/char18.h" /* $B%-%c%i%/%?(B $B!=(B $B%o%$%7%c%D$N%Q%8%c%^(B */
#include "graphics/8-plane/char19.h" /* $B%-%c%i%/%?(B $B!=(B $B%7!<%9%k!<$N%M%0%j%8%'(B */
#include "graphics/8-plane/char20.h" /* $B%-%c%i%/%?(B $B!=(B $B$_$($J$$%I%l%9(B */


/*
 *  1 plane $B2hA|%G!<%?(B
 */

#include "graphics/xbm/cbase1.xbm"  /* $BJ8;zHW(B $B!=(B $B%T%/%A%c!J@D!K(B */
#include "graphics/xbm/cbase2.xbm"  /* $BJ8;zHW(B $B!=(B $B?t;z!J@V!K(B */
#include "graphics/xbm/char01.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B$$$D$bCe$F$$$kI~(B */
#include "graphics/xbm/char02.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B6PL3@h$N@)I~(B */
#include "graphics/xbm/char03.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B?e6L$N%o%s%T!<%9(B */
#include "graphics/xbm/char04.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%;!<%i!<I~!JGr!K(B */
#include "graphics/xbm/char05.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%;!<%i!<I~!J:0!K(B */
#include "graphics/xbm/char06.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B$L$$$0$k$_9b9;@)I~(B */
#include "graphics/xbm/char07.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B9b9;$N@)I~$K%;!<%?!<(B */
#include "graphics/xbm/char08.xbm"  /* $B%-%c%i%/%?(B $B!=(B $BBNA`I~$H%V%k%^(B */
#include "graphics/xbm/char09.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%9%/!<%k?eCe(B */
#include "graphics/xbm/char10.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%m!<%l%0$N?eCe!J@V!K(B */
#include "graphics/xbm/char11.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B$d$5$7$$IX7Y$5$s(B */
#include "graphics/xbm/char12.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B4G8nIX$5$s$NGr0a(B */
#include "graphics/xbm/char13.xbm"  /* $B%-%c%i%/%?(B $B!=(B X11$B65=$F;1!$N%7%9%?!<(B */
#include "graphics/xbm/char14.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%A%c%$%J%I%l%9(B */
#include "graphics/xbm/char15.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B=w@o;N@oF.I~(B */
#include "graphics/xbm/char16.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%O%$%Q!<%P%H%k%9!<%D(B */
#include "graphics/xbm/char17.xbm"  /* $B%-%c%i%/%?(B $B!=(B $BD6%_%K$N%&%(%$%H%l%9(B */
#include "graphics/xbm/char18.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%o%$%7%c%D$N%Q%8%c%^(B */
#include "graphics/xbm/char19.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B%7!<%9%k!<$N%M%0%j%8%'(B */
#include "graphics/xbm/char20.xbm"  /* $B%-%c%i%/%?(B $B!=(B $B$_$($J$$%I%l%9(B */


/*
 *  $B2hA|%G!<%?$N%F!<%V%k(B
 */

/* 8 plane $B2hA|%G!<%?(B (PixelImage $B%G!<%?(B) $B$N%F!<%V%k(B $B!=(B $BJ8;zHW(B */
PixelImage	*cbasePImageTable[NUM_OF_CBASE] = {
    &cbase1Image,
    &cbase2Image,
};

/* 8 plane $B2hA|%G!<%?(B (PixelImage $B%G!<%?(B) $B$N%F!<%V%k(B $B!=(B $B%-%c%i%/%?(B */
PixelImage	*charPImageTable[NUM_OF_CHAR] = {
    &char01Image,
    &char02Image,
    &char03Image,
    &char04Image,
    &char05Image,
    &char06Image,
    &char07Image,
    &char08Image,
    &char09Image,
    &char10Image,
    &char11Image,
    &char12Image,
    &char13Image,
    &char14Image,
    &char15Image,
    &char16Image,
    &char17Image,
    &char18Image,
    &char19Image,
    &char20Image,
};

/* 1 plane $B2hA|%G!<%?$N%F!<%V%k(B $B!=(B $BJ8;zHW(B */
BitmapTable	cbaseBitmapTable[NUM_OF_CBASE] = {
    { cbase1_width, cbase1_height, cbase1_bits, },
    { cbase2_width, cbase2_height, cbase2_bits, },
};

/* 1 plane $B2hA|%G!<%?$N%F!<%V%k(B $B!=(B $B%-%c%i%/%?(B */
BitmapTable	charBitmapTable[NUM_OF_CHAR] = {
    { char01_width, char01_height, char01_bits, },
    { char02_width, char02_height, char02_bits, },
    { char03_width, char03_height, char03_bits, },
    { char04_width, char04_height, char04_bits, },
    { char05_width, char05_height, char05_bits, },
    { char06_width, char06_height, char06_bits, },
    { char07_width, char07_height, char07_bits, },
    { char08_width, char08_height, char08_bits, },
    { char09_width, char09_height, char09_bits, },
    { char10_width, char10_height, char10_bits, },
    { char11_width, char11_height, char11_bits, },
    { char12_width, char12_height, char12_bits, },
    { char13_width, char13_height, char13_bits, },
    { char14_width, char14_height, char14_bits, },
    { char15_width, char15_height, char15_bits, },
    { char16_width, char16_height, char16_bits, },
    { char17_width, char17_height, char17_bits, },
    { char18_width, char18_height, char18_bits, },
    { char19_width, char19_height, char19_bits, },
    { char20_width, char20_height, char20_bits, },
};
